using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Visualizacion;
using Exferia_Compras._3_Vistas.Controladoras;
using Exferia_Compras.General;
using Exferia_Controles;
using Exferia_Controles.ControlesAuxiliares;
using Exferia_EntityFramework;
using Exferia_General;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Globalization;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Windows.Forms;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_Compras._3_Vistas
{ 
    public partial class P_DevolucionPago : Exferia_Formularios.P_Base_Mantenimientos
    {
        #region Variables General
        private P_DevolucionPago_Controladora g_obj_Controladora;
        private int g_int_CentroInformacion_Ancho = 150;

        private bool g_bol_ConstructorPantalla_Terminado_Correctamente = true;
        public PRV_OpcionesDetalle g_mdl_PRV_OpcionesDetalle = null;

        internal List<INTERNO_Permisos_Modelo> g_lst_INTERNO_Permisos_Modelo = null;

        //Variables paginador......................................................................................
        public Funciones_Paginador g_obj_Funciones_Paginador;
        private System.Windows.Forms.Timer g_timer_Paginar = new System.Windows.Forms.Timer();

        private COM_Pagos g_mdl_COM_Pagos_Recibido = null;
        #endregion

        #region Objetos en Pantalla

        // CTU_Cartera_Compras
        internal CTU_Cartera_Compras CTU_Cartera_Compras_Devolucion { get { return ctu_P_DevolucionesPago_CarteraCompra; } }

        // Exferia_ArbolSecundarioSeleccion
        internal Exferia_ArbolSecundarioSeleccion Exferia_ArbolSecundarioSeleccion_DevolucionesPagos { get { return ex_trv_P_DevolucionPago_ArbolSecundarioSeleccion; } }

        //Exferia_Button
        internal Exferia_Button Exferia_Button_CerrarAbrir { get { return ex_btn_P_DevolucionPago_CerrarAbrir; } }
        internal Exferia_Button Exferia_Button_Volcado { get { return ex_btn_P_DevolucionPago_Volcado; } }
        internal Exferia_Button Exferia_Button_Cuentas { get { return ex_btn_P_DevolucionPago_Cuentas; } }

        //Exferia_F3_SoloSeleccion
        internal Exferia_F3_SoloSeleccion Exferia_F3_SoloSeleccion_Ejercicio { get { return ex_usc_F3_P_DevolucionPago_Ejercicio; } }
        internal Exferia_F3_SoloSeleccion Exferia_F3_SoloSeleccion_Delegacion { get { return ex_usc_F3_P_DevolucionPago_Delegacion; } }
        internal Exferia_F3_SoloSeleccion Exferia_F3_SoloSeleccion_Vencimiento { get { return ex_usc_F3_P_DevolucionPago_Vencimiento; } }
        internal Exferia_F3_SoloSeleccion Exferia_F3_SoloSeleccion_Tesoreria { get { return ex_usc_F3_P_DevolucionPago_Tesoreria; } }
        internal Exferia_F3_SoloSeleccion Exferia_F3_SoloSeleccion_ClaveAnalitica { get { return ex_usc_F3_P_DevolucionPago_ClaveAnalitica; } }
        internal Exferia_F3_SoloSeleccion Exferia_F3_SoloSeleccion_ClavePredefinida_Devolucion { get { return ex_usc_F3_P_DevolucionPago_ClavePredefinida_Devolucion; } }
        internal Exferia_F3_SoloSeleccion Exferia_F3_SoloSeleccion_Proveedor { get { return ex_usc_F3_P_DevolucionPago_Proveedor; } }

        //Exferia_F3_SoloSeleccion_Simple
        internal Exferia_F3_SoloSeleccion_Simple Exferia_F3_SoloSeleccion_Simple_FacturaCabecera { get { return ex_usc_F3_P_DevolucionPago_FacturaCabecera; } }
        internal Exferia_F3_SoloSeleccion_Simple Exferia_F3_SoloSeleccion_Simple_Pago { get { return ex_usc_F3_P_DevolucionPago_Pago; } }

        //Exferia_FechaSeleccion
        internal Exferia_FechaSeleccion Exferia_FechaSeleccion_Fecha { get { return ex_usc_P_DevolucionPago_Fecha; } }

        // Exferia_Label_SinColor
        internal Exferia_Label_SinColor Exferia_Label_SinColor_Advertencia_Ejercicio { get { return ex_lbl_Advertencia_Ejercicio; } }

        // Exferia_Label
        internal Exferia_Label Exferia_Label_Importe { get { return ex_lbl_P_DevolucionPago_Importe; } }

        // Exferia_Paginador
        internal Exferia_Paginador Exferia_Paginador_Devolucions { get { return ex_Paginador; } }

        // Exferia_TextBox
        internal Exferia_TextBox Exferia_TextBox_Codigo { get { return ex_txt_P_DevolucionPago_Codigo; } }
        internal Exferia_TextBox Exferia_TextBox_Comision { get { return ex_txt_P_DevolucionPago_Comision; } }
        internal Exferia_TextBox Exferia_TextBox_IVAComision { get { return ex_txt_P_DevolucionPago_IVAComision; } }
        internal Exferia_TextBox Exferia_TextBox_IVAComisionCalculo { get { return ex_txt_P_DevolucionPago_IVAComisionCalculo; } }
        internal Exferia_TextBox Exferia_TextBox_Correo { get { return ex_txt_P_DevolucionPago_Correo; } }
        internal Exferia_TextBox Exferia_TextBox_Observaciones { get { return ex_txt_P_DevolucionPago_Observaciones; } }
        internal Exferia_TextBox Exferia_TextBox_Importe { get { return ex_txt_P_DevolucionPago_Importe; } }

        // Panel
        internal Panel Panel_DatosPantalla { get { return pnl_DatosPantalla; } }
        #endregion

        #region Constructor
        public P_DevolucionPago(INTERNO_ValoresGenerales_Modelo _mdl_INTERNO_ValoresGenerales_Modelo, DateTime _dtt_FechaTrabajo, PRV_OpcionesDetalle _mdl_PRV_OpcionesDetalle, COM_Pagos _mdl_COM_Pagos)
        {
            InitializeComponent();

            try
            {
                Repintar.Empezar(this);

                CheckForIllegalCrossThreadCalls = false;

                //Empresa seleccionada y fecha de trabajo ....................................................
                P_Base_ValoresGenerales = _mdl_INTERNO_ValoresGenerales_Modelo;
                P_Base_FechaTrabajo = _dtt_FechaTrabajo;

                //Instanciar Controladora
                g_obj_Controladora = new P_DevolucionPago_Controladora(this);

                //Ejercicio Actual
                g_obj_Controladora.g_mdl_GEN_EjerciciosActivos_Empresa = Variables.G_MDL_INTERNO_VALORESGENERALES_MODELO.EjercicioActivo;
                g_mdl_COM_Pagos_Recibido = _mdl_COM_Pagos;

                //Datos de Opciones detalle
                g_mdl_PRV_OpcionesDetalle = _mdl_PRV_OpcionesDetalle;

                //Buscar los Permisos
                g_lst_INTERNO_Permisos_Modelo = Datos_Generales.Permisos_Buscar(g_mdl_PRV_OpcionesDetalle.opcion);

                //Poner los Botones que no se Spueden poner bloqueados o de solo lectura
                ex_btn_P_DevolucionPago_Borrar.Exferia_Button_Bloqueable = false;
                ex_btn_P_DevolucionPago_Grabar.Exferia_Button_Bloqueable = false;
                ex_btn_P_DevolucionPago_CerrarAbrir.Exferia_Button_Bloqueable = false;
                ex_btn_P_DevolucionPago_Volcado.Exferia_Button_Bloqueable = false;
                ex_btn_P_DevolucionPago_Cuentas.Exferia_Button_Bloqueable = false;
                ex_btn_P_DevolucionPago_ArbolSecundarioSeleccion_MostrarOcultar.Exferia_Button_Bloqueable = false;

                //Mirar si hay que bloquear los controles, si solo puede ver los datos
                if ((P_Base_TipoAperturaPantalla != 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Modificar, false)) == false)
                {
                    //Bloqueo los Controles
                    SoloLectura.Empezar(this, true);
                }

                //Titulo de la Pantalla .............................................................................
                P_Base_TituloPantalla = _mdl_PRV_OpcionesDetalle.descripcion_TituloMantenimiento;

                if (Variables.G_DCT_CONFIGURACIONPANTALLA != null && Variables.G_DCT_CONFIGURACIONPANTALLA.Count > 0)
                {
                    //centro informacion
                    if (Variables.G_DCT_CONFIGURACIONPANTALLA.ContainsKey(nameof(P_DevolucionPago)))
                    {
                        g_int_CentroInformacion_Ancho = Variables.G_DCT_CONFIGURACIONPANTALLA[nameof(P_DevolucionPago)].CENTROINFORMACION_Ancho;
                    }
                }

                // Label con Empresa Seleccionada 
                if (P_Base_ValoresGenerales != null)
                {
                    try
                    {
                        P_Base_Mantenimientos_InformacionEmpresaSeleccionada = P_Base_ValoresGenerales.str_Empresa_Descripcion + " - " +
                                                                "(" + P_Base_FechaTrabajo.ToString("dd/MM/yyyy") + ")";

                    }
                    catch (Exception ex)
                    {
                        //No se muestra mensaje pero se guarda en el log
                        Control_Errores.Errores_Log("", ex, nameof(P_DevolucionPago) + "/" + nameof(P_DevolucionPago));
                    }
                }
                //....................................................................................................

                //Bloquear pantalla hasta que termine la carga por defecto .....
                Enabled = false;
                //.............................................................

                g_obj_Funciones_Paginador = new Funciones_Paginador();

                //Rellenar para los F3 .......................................
                //EJERCICIO
                ex_usc_F3_P_DevolucionPago_Ejercicio.Exferia_F3_SoloSeleccion_PRINCIPAL_Opcion_BuscarDatos = Variables.G_STR_OPCION_GEN_EJERCICIOACTIVO;
                ex_usc_F3_P_DevolucionPago_Ejercicio.Exferia_F3_SoloSeleccion_PantallaContenedora = this;
                ex_usc_F3_P_DevolucionPago_Ejercicio.Exferia_F3_SoloSeleccion_PRINCIPAL_BUSCARTITULO = false;

                //DELEGACION
                ex_usc_F3_P_DevolucionPago_Delegacion.Exferia_F3_SoloSeleccion_PRINCIPAL_Opcion_BuscarDatos = Variables.G_STR_OPCION_GEN_DELEGACION;
                ex_usc_F3_P_DevolucionPago_Delegacion.Exferia_F3_SoloSeleccion_PantallaContenedora = this;

                //PROVEEDOR
                ex_usc_F3_P_DevolucionPago_Proveedor.Exferia_F3_SoloSeleccion_PRINCIPAL_Opcion_BuscarDatos = Variables.G_STR_OPCION_MAE_PROVEEDOR;
                ex_usc_F3_P_DevolucionPago_Proveedor.Exferia_F3_SoloSeleccion_PantallaContenedora = this;

                //FACTURACABECERA_AUX
                ex_usc_F3_P_DevolucionPago_FacturaCabecera.Exferia_F3_SoloSeleccion_Simple_PRINCIPAL_Opcion_BuscarDatos = Variables.G_STR_OPCION_COM_FACTURACABECERA_AUX;
                ex_usc_F3_P_DevolucionPago_FacturaCabecera.Exferia_F3_SoloSeleccion_Simple_PantallaContenedora = this;
                
                //VENCIMIENTO
                ex_usc_F3_P_DevolucionPago_Vencimiento.Exferia_F3_SoloSeleccion_PRINCIPAL_Opcion_BuscarDatos = Variables.G_STR_OPCION_COM_VENCIMIENTO;
                ex_usc_F3_P_DevolucionPago_Vencimiento.Exferia_F3_SoloSeleccion_PantallaContenedora = this;

                //PAGO
                ex_usc_F3_P_DevolucionPago_Pago.Exferia_F3_SoloSeleccion_Simple_PRINCIPAL_Opcion_BuscarDatos = Variables.G_STR_OPCION_COM_PAGO;
                ex_usc_F3_P_DevolucionPago_Pago.Exferia_F3_SoloSeleccion_Simple_PantallaContenedora = this;

                //TESORERIA
                ex_usc_F3_P_DevolucionPago_Tesoreria.Exferia_F3_SoloSeleccion_PRINCIPAL_Opcion_BuscarDatos = Variables.G_STR_OPCION_MAE_TESORERIA;
                ex_usc_F3_P_DevolucionPago_Tesoreria.Exferia_F3_SoloSeleccion_PantallaContenedora = this;

                //CLAVE ANALITICA
                ex_usc_F3_P_DevolucionPago_ClaveAnalitica.Exferia_F3_SoloSeleccion_PRINCIPAL_Opcion_BuscarDatos = Variables.G_STR_OPCION_CTA_CLAVEANALITICA;
                ex_usc_F3_P_DevolucionPago_ClaveAnalitica.Exferia_F3_SoloSeleccion_PantallaContenedora = this;

                //PREDEFINIDOCABECERA (Devolucion)
                ex_usc_F3_P_DevolucionPago_ClavePredefinida_Devolucion.Exferia_F3_SoloSeleccion_PRINCIPAL_Opcion_BuscarDatos = Variables.G_STR_OPCION_CTA_PREDEFINIDOCABECERA;
                ex_usc_F3_P_DevolucionPago_ClavePredefinida_Devolucion.Exferia_F3_SoloSeleccion_PantallaContenedora = this;
                ex_usc_F3_P_DevolucionPago_ClavePredefinida_Devolucion.Exferia_F3_SoloSeleccion_PRINCIPAL_BUSCARTITULO = false;
                ex_usc_F3_P_DevolucionPago_ClavePredefinida_Devolucion.Exferia_F3_SoloSeleccion_RELACIONADOS_Padre_OPCION = Variables.G_STR_OPCION_CTA_PREDEFINIDOFICHERO;
                ex_usc_F3_P_DevolucionPago_ClavePredefinida_Devolucion.Exferia_F3_SoloSeleccion_RELACIONADOS_Padre_ID = Variables.G_PREDEFINIDOFICHEROS_DEVOLUCIONESDEPAGOS.Id;
            }
            catch (Control_Errores)
            {
                g_bol_ConstructorPantalla_Terminado_Correctamente = false;
            }
            catch (Exception ex)
            {
                g_bol_ConstructorPantalla_Terminado_Correctamente = false;

                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log("", ex, nameof(P_DevolucionPago) + "/" + nameof(P_DevolucionPago));
            }
            finally
            {
                //Bloquear pantalla hasta que termine la carga por defecto .....
                Enabled = true;
                //.............................................................
            }
        }

        #endregion

        #region Inicio de pantalla
        private void P_DevolucionPago_Load(object sender, EventArgs e)
        {
            try
            {
                #region TIMER PAGINACION
                //Configurar el Timer para Paginacion ###############################################################
                g_timer_Paginar.Interval = 1000;
                g_timer_Paginar.Tick += delegate (object s, EventArgs ee)
                {
                    g_timer_Paginar.Stop();
                    try
                    {
                        g_obj_Controladora.RecargarDatos();
                    }
                    catch (Control_Errores)
                    {
                        Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                        Salir_P_Base();
                    }

                };
                #endregion

                #region Resumen Facturas
                ctu_P_DevolucionesPago_CarteraCompra.Inicializar_Control(P_Base_ValoresGenerales, P_Base_FechaTrabajo, this);
                #endregion
            }
            catch (Exception ex)
            {
                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log("", ex, nameof(P_DevolucionPago) + "/" + nameof(P_DevolucionPago_Load));

                g_bol_ConstructorPantalla_Terminado_Correctamente = false;
            }
        }
        private void P_DevolucionPago_Shown(object sender, EventArgs e)
        {
            try
            {
                if (g_bol_ConstructorPantalla_Terminado_Correctamente)
                {
                    // Si el Tipo de Apertura de Pantalla es Añadir(g_int_tipoAperturaPantalla = 0), se desactivan los botones correspondientes
                    // Añadir
                    if (this.P_Base_TipoAperturaPantalla == 0)
                    {

                        P_Base_TituloPantalla = P_Base_TituloPantalla + " - Añadir";

                        g_obj_Controladora.Datos_PorDefecto();

                        ActivarBotones(false);

                        //Se cambia el valor de la variable para no salte el evento de se modifico algo
                        g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial = false;

                        //Poner Texto predeterminado y foco
                        ex_usc_F3_P_DevolucionPago_FacturaCabecera.Exferia_F3_SoloSeleccion_Simple_Foco();

                        g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial = true;

                        //Si viene de un Vencimiento relleno los datos
                        if (g_mdl_COM_Pagos_Recibido != null)
                        {
                            g_obj_Controladora.CargarDatos_Desde_Pago(g_mdl_COM_Pagos_Recibido);
                        }

                    }
                    // Modificar
                    else
                    {
                        ActivarBotones(true);

                        //Paginacion
                        if (P_Base_PantallaOrigen != null &&
                            P_Base_PantallaOrigen.P_Base_Objetos_Filtrados != null &&
                            P_Base_PantallaOrigen.P_Base_Objetos_Filtrados.Count > 0)
                        {
                            g_obj_Funciones_Paginador.Listado_ARecorrer(P_Base_PantallaOrigen.P_Base_Objetos_Filtrados.ToList(), 1);

                            // Asignando las paginas totales
                            Exferia_Paginador_Devolucions.PaginasTotales = g_obj_Funciones_Paginador.Numero_Paginas_Totales;
                        }
                        else
                        {
                            Exferia_Paginador_Devolucions.Visible = false;
                        }

                        g_obj_Controladora.RecargarDatos();
                    }
                }
                else
                {
                    Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                    Salir_P_Base();
                }
            }
            catch (Control_Errores)
            {
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                Salir_P_Base();
            }
            catch (Exception ex)
            {
                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log("", ex, nameof(P_DevolucionPago) + "/" + nameof(P_DevolucionPago_Shown));

                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                Salir_P_Base();
            }
        }
        public void ActivarBotones(bool _bol_Activar)
        {
            if (Exferia_Paginador_Devolucions.Visible)
            {
                Exferia_Paginador_Devolucions.Visible = _bol_Activar;
            }

            if (ex_btn_P_DevolucionPago_Borrar.Enabled)
            {
                ex_btn_P_DevolucionPago_Borrar.Enabled = _bol_Activar;
            }
        }
        #endregion

        #region Ejercicio
        private void ex_usc_F3_P_DevolucionPago_Ejercicio_Exferia_F3_SoloSeleccion_Evento_TerminoBusqueda(object sender, EventArgs e)
        {
            //Tiene un Ejercicio Seleccionado correcto
            if (ex_usc_F3_P_DevolucionPago_Ejercicio.Exferia_F3_SoloSeleccion_Id > -1)
            {
                //Desbloqueamos la busqueda del documento
                if (!g_obj_Controladora.g_lng_idEjercicio.Equals(ex_usc_F3_P_DevolucionPago_Ejercicio.Exferia_F3_SoloSeleccion_Id))
                {
                    g_obj_Controladora.g_lng_idEjercicio = ex_usc_F3_P_DevolucionPago_Ejercicio.Exferia_F3_SoloSeleccion_Id;

                    g_obj_Controladora.Bloquea_Desbloquea(P_DevolucionPago_Controladora.G_ENUM_NIVELES.Factura, P_DevolucionPago_Controladora.G_ENUM_ACCIONES_BLOQUEO.Desbloquear_SiActual);

                    g_obj_Controladora.FacturaCabecera_Actualizar_DatosFiltro();
                }
            }
            else
            {
                //Vaciamos y bloqueamos el Documento y todos los datos relacionados
                g_obj_Controladora.g_lng_idEjercicio = -1;

                ex_usc_F3_P_DevolucionPago_FacturaCabecera.Exferia_F3_SoloSeleccion_Simple_RELACIONADOS = null;

                g_obj_Controladora.Bloquea_Desbloquea(P_DevolucionPago_Controladora.G_ENUM_NIVELES.Factura, P_DevolucionPago_Controladora.G_ENUM_ACCIONES_BLOQUEO.Bloquear_SiActual);
            }
        }
        #endregion

        #region Delegacion
        private void ex_usc_F3_P_DevolucionPago_Delegacion_Exferia_F3_SoloSeleccion_Evento_TerminoBusqueda(object sender, EventArgs e)
        {
            //Tiene una Delegacion Seleccionada correcto
            if (ex_usc_F3_P_DevolucionPago_Delegacion.Exferia_F3_SoloSeleccion_Id > -1)
            {
                //Desbloqueamos la busqueda del documento
                if (!g_obj_Controladora.g_lng_idDelegacion.Equals(ex_usc_F3_P_DevolucionPago_Delegacion.Exferia_F3_SoloSeleccion_Id))
                {
                    g_obj_Controladora.g_lng_idDelegacion = ex_usc_F3_P_DevolucionPago_Delegacion.Exferia_F3_SoloSeleccion_Id;

                    g_obj_Controladora.Bloquea_Desbloquea(P_DevolucionPago_Controladora.G_ENUM_NIVELES.Factura, P_DevolucionPago_Controladora.G_ENUM_ACCIONES_BLOQUEO.Desbloquear_SiActual);

                    g_obj_Controladora.FacturaCabecera_Actualizar_DatosFiltro();
                }
            }
            else
            {
                //Vaciamos y bloqueamos el Documento y todos los datos relacionados
                g_obj_Controladora.g_lng_idDelegacion = -1;

                ex_usc_F3_P_DevolucionPago_FacturaCabecera.Exferia_F3_SoloSeleccion_Simple_RELACIONADOS = null;

                g_obj_Controladora.Bloquea_Desbloquea(P_DevolucionPago_Controladora.G_ENUM_NIVELES.Factura, P_DevolucionPago_Controladora.G_ENUM_ACCIONES_BLOQUEO.Desbloquear_SiActual);

            }
        }

        #endregion

        #region Proveedor
        private void ex_usc_F3_P_DevolucionPago_Proveedor_Exferia_F3_SoloSeleccion_Evento_TerminoBusqueda(object sender, EventArgs e)
        {
            //Tiene una entidad Seleccionada correcto
            if (ex_usc_F3_P_DevolucionPago_Proveedor.Exferia_F3_SoloSeleccion_Id > -1)
            {
                //Desbloqueamos la busqueda del documento
                if (!g_obj_Controladora.g_lng_idProveedor.Equals(ex_usc_F3_P_DevolucionPago_Proveedor.Exferia_F3_SoloSeleccion_Id))
                {
                    g_obj_Controladora.g_lng_idProveedor = ex_usc_F3_P_DevolucionPago_Proveedor.Exferia_F3_SoloSeleccion_Id;
                }
            }
            else
            {
                g_obj_Controladora.g_lng_idProveedor = -1;
            }

            g_obj_Controladora.FacturaCabecera_Actualizar_DatosFiltro();
        }
        #endregion

        #region FacturasCabecera
        private void ex_usc_F3_P_DevolucionPago_FacturaCabecera_Exferia_F3_SoloSeleccion_Simple_Evento_TerminoBusqueda(object sender, EventArgs e)
        {
            //Tiene un FacturaCabecera Seleccionado correcto
            if (ex_usc_F3_P_DevolucionPago_FacturaCabecera.Exferia_F3_SoloSeleccion_Simple_Id > -1)
            {
                //Desbloqueamos la busqueda del documento
                if ((g_obj_Controladora.g_mdl_INTERNO_COM_FacturasCabecera_Modelo == null) ||
                    (g_obj_Controladora.g_mdl_INTERNO_COM_FacturasCabecera_Modelo != null && !g_obj_Controladora.g_mdl_INTERNO_COM_FacturasCabecera_Modelo.id.Equals(ex_usc_F3_P_DevolucionPago_FacturaCabecera.Exferia_F3_SoloSeleccion_Simple_Id)))
                {
                    g_obj_Controladora.Bloquea_Desbloquea(P_DevolucionPago_Controladora.G_ENUM_NIVELES.Vencimento, P_DevolucionPago_Controladora.G_ENUM_ACCIONES_BLOQUEO.Desbloquear_SiActual);

                    //Rellenar Valores
                    g_obj_Controladora.Rellenar_Datos_FacturaCabecera(ex_usc_F3_P_DevolucionPago_FacturaCabecera.Exferia_F3_SoloSeleccion_Simple_Id);

                    //Actualizar el control de Resumen de Facturas
                    ctu_P_DevolucionesPago_CarteraCompra.Rellenar_DataGrid(G_ENUM_CTU_CARTERA_COMPRAS_TIPODOCUMENTOFILTRO.FacturasCabeceraCompra, ex_usc_F3_P_DevolucionPago_FacturaCabecera.Exferia_F3_SoloSeleccion_Simple_Id, true);
                }
            }
            else
            {
                g_obj_Controladora.Vaciar_Datos(P_DevolucionPago_Controladora.G_ENUM_NIVELES.Factura, P_DevolucionPago_Controladora.G_ENUM_ACCIONES_VACIADO.Vaciar_SiActual, false, true);
                g_obj_Controladora.Bloquea_Desbloquea(P_DevolucionPago_Controladora.G_ENUM_NIVELES.Vencimento, P_DevolucionPago_Controladora.G_ENUM_ACCIONES_BLOQUEO.Bloquear_SiActual);

                //Actualizar el control de Resumen de Facturas
                ctu_P_DevolucionesPago_CarteraCompra.Rellenar_DataGrid(G_ENUM_CTU_CARTERA_COMPRAS_TIPODOCUMENTOFILTRO.FacturasCabeceraCompra, -1, true);
            }
        }
        #endregion

        #region Vencimiento
        private void ex_usc_F3_P_DevolucionPago_Vencimiento_Exferia_F3_SoloSeleccion_Evento_TerminoBusqueda(object sender, EventArgs e)
        {
            //Tiene una Vencimiento Seleccionada correcto
            if (ex_usc_F3_P_DevolucionPago_Vencimiento.Exferia_F3_SoloSeleccion_Id > -1)
            {
                //Desbloqueamos la busqueda del documento
                if ((g_obj_Controladora.g_mdl_INTERNO_COM_Vencimientos_Modelo == null) ||
                    (g_obj_Controladora.g_mdl_INTERNO_COM_Vencimientos_Modelo != null && !g_obj_Controladora.g_mdl_INTERNO_COM_Vencimientos_Modelo.id.Equals(ex_usc_F3_P_DevolucionPago_Vencimiento.Exferia_F3_SoloSeleccion_Id)))
                {
                    g_obj_Controladora.Bloquea_Desbloquea(P_DevolucionPago_Controladora.G_ENUM_NIVELES.Pago, P_DevolucionPago_Controladora.G_ENUM_ACCIONES_BLOQUEO.Desbloquear_SiActual);

                    g_obj_Controladora.Rellenar_Datos_Vencimiento(ex_usc_F3_P_DevolucionPago_Vencimiento.Exferia_F3_SoloSeleccion_Id);
                }
            }
            else
            {
                g_obj_Controladora.Vaciar_Datos(P_DevolucionPago_Controladora.G_ENUM_NIVELES.Vencimento, P_DevolucionPago_Controladora.G_ENUM_ACCIONES_VACIADO.Vaciar_SiActual, false, true);
                g_obj_Controladora.Bloquea_Desbloquea(P_DevolucionPago_Controladora.G_ENUM_NIVELES.Pago, P_DevolucionPago_Controladora.G_ENUM_ACCIONES_BLOQUEO.Bloquear_SiActual);
            }
        }
        #endregion

        #region Pago
        private void ex_usc_F3_P_DevolucionPago_Pago_Exferia_F3_SoloSeleccion_Simple_Evento_TerminoBusqueda(object sender, EventArgs e)
        {
            //Tiene una Pago Seleccionada correcto
            if (ex_usc_F3_P_DevolucionPago_Pago.Exferia_F3_SoloSeleccion_Simple_Id > -1)
            {
                //Desbloqueamos la busqueda del documento
                if ((g_obj_Controladora.g_mdl_COM_Pagos == null) ||
                    (g_obj_Controladora.g_mdl_COM_Pagos != null && !g_obj_Controladora.g_mdl_COM_Pagos.id.Equals(ex_usc_F3_P_DevolucionPago_Pago.Exferia_F3_SoloSeleccion_Simple_Id)))
                {
                    g_obj_Controladora.Bloquea_Desbloquea(P_DevolucionPago_Controladora.G_ENUM_NIVELES.RestoDatos, P_DevolucionPago_Controladora.G_ENUM_ACCIONES_BLOQUEO.Desbloquear_SiActual);

                    g_obj_Controladora.Rellenar_Datos_Pago(ex_usc_F3_P_DevolucionPago_Pago.Exferia_F3_SoloSeleccion_Simple_Id);
                }
            }
            else
            {
                g_obj_Controladora.Vaciar_Datos(P_DevolucionPago_Controladora.G_ENUM_NIVELES.Pago, P_DevolucionPago_Controladora.G_ENUM_ACCIONES_VACIADO.Vaciar_SiActual, false, true);
                g_obj_Controladora.Bloquea_Desbloquea(P_DevolucionPago_Controladora.G_ENUM_NIVELES.RestoDatos, P_DevolucionPago_Controladora.G_ENUM_ACCIONES_BLOQUEO.Bloquear_SiActual);
            }
        }
        #endregion

        #region Se Ejecuta desde la Pantalla que se llamo anteriormente
        public override void P_Base_EjecutarFuncion(int _int_Tipo)
        {
            try
            {
                //Se utiliza si en la Pantalla de VolcadoCabecera se pasa al Diario los datos
                if (_int_Tipo == 1)
                {
                    g_obj_Controladora.Mostrar_CerradoVolcado();
                }
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_DevolucionPago) + "/" + nameof(P_Base_EjecutarFuncion));
            }
        }
        #endregion

        #region Botones Grabar,Borrar,Cerrar,Volcar,Mostrar Volcado
        private void ex_btn_P_Devolucion_Grabar_Click(object sender, EventArgs e)
        {
            Grabar();
        }
        private void Grabar()
        {
            if (g_obj_Controladora.g_obj_ENUM_VALIDACIONFECHAS_TIPOCIERRE.Equals(G_ENUM_VALIDACIONFECHAS_TIPOCIERRE.CierreAdministrativo))
            {
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_FECHASEJERCICIOS_ETIQUETA_TIENECIERREADMINISTRATIVO());
            }
            else if (g_obj_Controladora.g_obj_ENUM_VALIDACIONFECHAS_TIPOCIERRE.Equals(G_ENUM_VALIDACIONFECHAS_TIPOCIERRE.CierreContable))
            {
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_FECHASEJERCICIOS_ETIQUETA_TIENECIERRECONTABLE());
            }
            else
            {
                if (//Añadir
                    (P_Base_TipoAperturaPantalla == 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Anadir, true)) ||
                    //Modificar
                    (P_Base_TipoAperturaPantalla != 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Modificar, true)))
                {
                    //Ver el estado del Documento
                    if (g_obj_Controladora.g_str_Estado.Equals(Variables.G_STR_ESTADO_CONTABILIDAD_VOLCADO))
                    {
                        Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_DOCUMENTO_VOLCADO());
                    }
                    else if (g_obj_Controladora.g_str_Estado.Equals(Variables.G_STR_ESTADO_CONTABILIDAD_CERRADO))
                    {
                        Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_DOCUMENTO_CERRADO());
                    }
                    else
                    {
                        g_obj_Controladora.GrabarDatos(true);

                        if (g_obj_Controladora.g_bol_GrabarDatos_TerminoCorrectamente)
                        {
                            //Actualizar el control de Resumen de Facturas
                            ctu_P_DevolucionesPago_CarteraCompra.Rellenar_DataGrid(G_ENUM_CTU_CARTERA_COMPRAS_TIPODOCUMENTOFILTRO.FacturasCabeceraCompra, g_obj_Controladora.g_mdl_INTERNO_COM_FacturasCabecera_Modelo.id, true);

                            //Actualizar la pantalla anterior si fuera vencimiento
                            if (P_Base_PantallaOrigen != null)
                            {
                                P_Base_PantallaOrigen.P_Base_ActualizarRegistro_ConObjeto(Variables.G_STR_OPCION_COM_DEVOLUCIONPAGO, G_ENUM_TIPOACCION.INT_NADA);
                            }
                        }
                    }
                }
            }

        }

        private void ex_btn_P_Devolucion_Borrar_Click(object sender, EventArgs e)
        {
            Borrar();
        }
        private void Borrar()
        {
            if (g_obj_Controladora.g_obj_ENUM_VALIDACIONFECHAS_TIPOCIERRE.Equals(G_ENUM_VALIDACIONFECHAS_TIPOCIERRE.CierreAdministrativo))
            {
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_FECHASEJERCICIOS_ETIQUETA_TIENECIERREADMINISTRATIVO());
            }
            else if (g_obj_Controladora.g_obj_ENUM_VALIDACIONFECHAS_TIPOCIERRE.Equals(G_ENUM_VALIDACIONFECHAS_TIPOCIERRE.CierreContable))
            {
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_FECHASEJERCICIOS_ETIQUETA_TIENECIERRECONTABLE());
            }
            else
            {
                if (Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Borrar, true))
                {
                    //Ver el estado del Documento
                    if (g_obj_Controladora.g_str_Estado.Equals(Variables.G_STR_ESTADO_CONTABILIDAD_VOLCADO))
                    {
                        Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_DOCUMENTO_VOLCADO());
                    }
                    else if (g_obj_Controladora.g_str_Estado.Equals(Variables.G_STR_ESTADO_CONTABILIDAD_CERRADO))
                    {
                        Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_DOCUMENTO_CERRADO());
                    }
                    else
                    {
                        g_obj_Controladora.BorrarDatos();
                    }
                }
            }
        }

        private void ex_btn_P_DevolucionPago_CerrarAbrir_Click(object sender, EventArgs e)
        {
            CerrarAbrir();
        }
        private void CerrarAbrir()
        {
            if (g_obj_Controladora.g_obj_ENUM_VALIDACIONFECHAS_TIPOCIERRE.Equals(G_ENUM_VALIDACIONFECHAS_TIPOCIERRE.CierreAdministrativo))
            {
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_FECHASEJERCICIOS_ETIQUETA_TIENECIERREADMINISTRATIVO());
            }
            else if (g_obj_Controladora.g_obj_ENUM_VALIDACIONFECHAS_TIPOCIERRE.Equals(G_ENUM_VALIDACIONFECHAS_TIPOCIERRE.CierreContable))
            {
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_FECHASEJERCICIOS_ETIQUETA_TIENECIERRECONTABLE());
            }
            else
            {

                //Tiene que tener Permisos para cerrar o abrir la Devolucion
                if (Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Bloquear, true, nameof(ex_btn_P_DevolucionPago_CerrarAbrir)))
                {
                    //Si no esta Volcado no se puede Abrir ni cerrar
                    if (!g_obj_Controladora.g_str_Estado.Equals(Variables.G_STR_ESTADO_CONTABILIDAD_VOLCADO))
                    {
                        //Esta Cerrado
                        if (ex_btn_P_DevolucionPago_CerrarAbrir.Tag.ToString().Equals("1"))
                        {
                            //Ver si en verdad esta cerrado
                            if (g_obj_Controladora.g_str_Estado.Equals(Variables.G_STR_ESTADO_CONTABILIDAD_CERRADO))
                            {
                                g_obj_Controladora.Abrir_Documento();
                            }
                            else
                            {
                                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_DOCUMENTO_NOCERRADO());
                            }
                        }
                        //Esta Abierto
                        else
                        {
                            //Ver si esta Devolucion ya ha sido Volcada
                            if (g_obj_Controladora.g_str_Estado.Equals(Variables.G_STR_ESTADO_CONTABILIDAD_ABIERTO))
                            {
                                if (g_obj_Controladora.ComprobarCambios_SinPreguntar())
                                {
                                    g_obj_Controladora.Cerrar_Documento();
                                }
                            }
                            else
                            {
                                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_DOCUMENTO_CERRADO());
                            }
                        }
                    }
                    else
                    {
                        Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_DOCUMENTO_VOLCADO());
                    }
                }

            }
        }

        private void ex_btn_P_DevolucionPago_Cuentas_Click(object sender, EventArgs e)
        {
            Ver_Volcado();
        }
        private void Ver_Volcado()
        {
            try
            {
                if (!Variables.G_BOL_MODULO_CONTABILIDAD_ACTIVA)
                {
                    Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_NOTIENEMODULOCONTABILIDADACTIVO());
                }
                else
                {
                    //Ver si esta Devolucion no ha sido Volcada
                    if (g_obj_Controladora.g_str_Estado.Equals(Variables.G_STR_ESTADO_CONTABILIDAD_CERRADO) ||
                         g_obj_Controladora.g_str_Estado.Equals(Variables.G_STR_ESTADO_CONTABILIDAD_VOLCADO))
                    {
                        INTERNO_OpcionesDetalle_Modelo mdl_INTERNO_OpcionesDetalle_Modelo = Datos_Generales.PRV_Opciones_Buscar_Detalles(Variables.G_STR_OPCION_CTA_VOLCADOCABECERA);

                        //Cargamos el ensamblado
                        Assembly m_assembly = Assembly.LoadFrom(Variables.G_STR_LIBRERIA_RUTAINICIAL + @"\" + mdl_INTERNO_OpcionesDetalle_Modelo.nombreLibreria + ".dll");
                        //Obtenemos el tipo de la clase
                        Type m_type = m_assembly.GetType(mdl_INTERNO_OpcionesDetalle_Modelo.nombreLibreria + "." + Variables.G_STR_LIBRERIA_OPCIONES);
                        //creamos la instancia
                        var obj_Clase = Activator.CreateInstance(m_type);
                        //Cargamos el metodo solicitado
                        MethodInfo obj_MethodInfo = obj_Clase.GetType().GetMethod(Variables.G_STR_LIBRERIA_OPCIONES_PROCEDIMIENTO_MOSTRAR_EN_MANTENIMIENTO, BindingFlags.Instance | BindingFlags.NonPublic);

                        //Obtener idVolcadoCabecera segun Fichero
                        CTA_VolcadoCabecera mdl_CTA_VolcadoCabecera = g_obj_Controladora.g_lst_CTA_VolcadoCabecera.Where(m => m.idPredefinidoFichero.Equals(Variables.G_PREDEFINIDOFICHEROS_DEVOLUCIONESDEPAGOS.Id)).FirstOrDefault();

                        if (mdl_CTA_VolcadoCabecera != null)
                        {
                            //Obtener valores
                            object[] arr_Parametros = { Variables.G_STR_OPCION_CTA_VOLCADOCABECERA,
                                                this,
                                                null,
                                                this.P_Base_ValoresGenerales,
                                                this.P_Base_FechaTrabajo,
                                                mdl_INTERNO_OpcionesDetalle_Modelo,
                                                mdl_CTA_VolcadoCabecera.id,
                                                "",
                                                "" ,
                                                null,
                                                null};
                            //Pasamos los parametros al metodo y lo ejecutamos
                            obj_MethodInfo.Invoke(obj_Clase, arr_Parametros);
                        }
                        else
                        {
                            Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_ERROR_ABRIR_DOCUMENTO());
                        }
                    }
                    else
                    {
                        Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_DOCUMENTO_NOCERRADO());
                    }
                }
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_DevolucionPago) + "/" + nameof(Ver_Volcado));
            }
        }

        private void ex_btn_P_DevolucionPago_Volcado_Click(object sender, EventArgs e)
        {
            VolcarDesvolcar();
        }
        private void VolcarDesvolcar()
        {
            if (!Variables.G_BOL_MODULO_CONTABILIDAD_ACTIVA)
            {
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_NOTIENEMODULOCONTABILIDADACTIVO());
            }
            else
            {
                if (g_obj_Controladora.g_obj_ENUM_VALIDACIONFECHAS_TIPOCIERRE.Equals(G_ENUM_VALIDACIONFECHAS_TIPOCIERRE.CierreContable))
                {
                    Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_FECHASEJERCICIOS_ETIQUETA_TIENECIERRECONTABLE());
                }
                else
                {
                    //Si no existe Pago no se puede Volcar
                    if (g_obj_Controladora.g_mdl_COM_DevolucionesPagos != null)
                    {
                        //Tiene que tener Permisos para volcar/desvolcar el Pago
                        if (Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Bloquear, true, nameof(ex_btn_P_DevolucionPago_Volcado)))
                        {
                            //Esta Volcado
                            if (ex_btn_P_DevolucionPago_Volcado.Tag.ToString().Equals("1"))
                            {
                                g_obj_Controladora.Desvolcar_Documento();
                            }
                            //Esta Desvolcado
                            else
                            {
                                //Primero Grabo los datos y actualizo el Modelo
                                g_obj_Controladora.GrabarDatos(false);

                                //Te quedas esperando a que termine la tarea asincrona de grabar
                                while (g_obj_Controladora.g_obj_TareaAsincrona_GrabarDatos.IsBusy)
                                    Application.DoEvents();

                                if (g_obj_Controladora.g_bol_GrabarDatos_TerminoCorrectamente)
                                {
                                    g_obj_Controladora.Volcar_Documento();
                                }
                            }
                        }
                    }
                    else
                    {
                        Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_DEBEGRABARPRIMERO(g_mdl_PRV_OpcionesDetalle.descripcion_Singular));
                    }
                }
            }
        }
        #endregion

        #region Comsion
        #region Comision Valor
        private string g_str_Comision_GotFocus = "";
        private void ex_txt_P_DevolucionPago_Comision_Exferia_TextBox_Evento_GotFocus(object sender, EventArgs e)
        {
            g_str_Comision_GotFocus = ex_txt_P_DevolucionPago_Comision.Text;
        }
        private void ex_txt_P_DevolucionPago_Comision_Exferia_TextBox_Evento_LostFocus(object sender, EventArgs e)
        {
            try
            {
                string str_Comision_LostFocus = ex_txt_P_DevolucionPago_Comision.Text;

                if (g_str_Comision_GotFocus != str_Comision_LostFocus)
                {
                    if (Funciones.IsNumeric(str_Comision_LostFocus))
                    {
                        if (ex_txt_P_DevolucionPago_IVAComision.Text.Trim().Length > 0 &&
                            Funciones.IsNumeric(ex_txt_P_DevolucionPago_IVAComision.Text.Trim()) &&
                            decimal.Parse(ex_txt_P_DevolucionPago_IVAComision.Text.Trim()) != 0m)
                        {
                            ex_txt_P_DevolucionPago_IVAComisionCalculo.Text = string.Format("{0:0.00}", (decimal.Parse(ex_txt_P_DevolucionPago_IVAComision.Text.Trim()) / 100m) * decimal.Parse(str_Comision_LostFocus));
                        }
                        else
                        {
                            ex_txt_P_DevolucionPago_IVAComisionCalculo.Text = "0,00";
                        }
                    }
                    else
                    {
                        ex_txt_P_DevolucionPago_IVAComisionCalculo.Text = "0,00";
                    }
                }
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_DevolucionPago) + "/" + nameof(ex_txt_P_DevolucionPago_Comision_Exferia_TextBox_Evento_LostFocus));
            }
        }
        #endregion

        #region Comicion Porcentaje
        private string g_str_IVAComision_GotFocus = "";
        private void ex_txt_P_DevolucionPago_IVAComision_Exferia_TextBox_Evento_GotFocus(object sender, EventArgs e)
        {
            g_str_IVAComision_GotFocus = ex_txt_P_DevolucionPago_IVAComision.Text;
        }
        private void ex_txt_P_DevolucionPago_IVAComision_Exferia_TextBox_Evento_LostFocus(object sender, EventArgs e)
        {
            try
            {
                string str_IVAComision_LostFocus = ex_txt_P_DevolucionPago_IVAComision.Text;

                if (g_str_IVAComision_GotFocus != str_IVAComision_LostFocus)
                {
                    if (Funciones.IsNumeric(str_IVAComision_LostFocus))
                    {
                        if (ex_txt_P_DevolucionPago_Comision.Text.Trim().Length > 0 &&
                            Funciones.IsNumeric(ex_txt_P_DevolucionPago_Comision.Text.Trim()) &&
                            decimal.Parse(ex_txt_P_DevolucionPago_Comision.Text.Trim()) != 0m)
                        {
                            ex_txt_P_DevolucionPago_IVAComisionCalculo.Text = string.Format("{0:0.00}", (decimal.Parse(ex_txt_P_DevolucionPago_IVAComision.Text.Trim()) / 100m) * decimal.Parse(ex_txt_P_DevolucionPago_Comision.Text));
                        }
                        else
                        {
                            ex_txt_P_DevolucionPago_Comision.Text = "0,00";
                        }
                    }
                    else
                    {
                        ex_txt_P_DevolucionPago_Comision.Text = "0,00";
                    }
                }
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_DevolucionPago) + "/" + nameof(ex_txt_P_DevolucionPago_IVAComision_Exferia_TextBox_Evento_LostFocus));
            }
        }
        #endregion

        #region Comisicon Importe
        private string g_str_IVAComisionCalculo_GotFocus = "";
        private void ex_txt_P_DevolucionPago_IVAComisionCalculo_Exferia_TextBox_Evento_GotFocus(object sender, EventArgs e)
        {
            g_str_IVAComisionCalculo_GotFocus = ex_txt_P_DevolucionPago_IVAComisionCalculo.Text;
        }
        private void ex_txt_P_DevolucionPago_IVAComisionCalculo_Exferia_TextBox_Evento_LostFocus(object sender, EventArgs e)
        {
            try
            {
                string str_IVAComisionCalculo_LostFocus = ex_txt_P_DevolucionPago_IVAComisionCalculo.Text;

                if (g_str_IVAComisionCalculo_GotFocus != str_IVAComisionCalculo_LostFocus)
                {
                    if (Funciones.IsNumeric(ex_txt_P_DevolucionPago_IVAComisionCalculo.Text))
                    {
                        string str_valor = string.Format("{0:0.00}", decimal.Parse(ex_txt_P_DevolucionPago_IVAComisionCalculo.Text));

                        ex_txt_P_DevolucionPago_Comision.Text = str_valor;
                        ex_txt_P_DevolucionPago_IVAComision.Text = "0,00";
                        ex_txt_P_DevolucionPago_IVAComisionCalculo.Text = str_valor;
                    }
                }
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_DevolucionPago) + "/" + nameof(ex_txt_P_DevolucionPago_IVAComisionCalculo_Exferia_TextBox_Evento_LostFocus));
            }
        }
        #endregion

        #endregion

        #region Arbol Secundario Seleccion
        private void ex_btn_P_DevolucionPago_ArbolSecundarioSeleccion_MostrarOcultar_Click(object sender, EventArgs e)
        {
            if (spl_P_DevolucionPago_Principal.Panel2Collapsed)
            {
                spl_P_DevolucionPago_Principal.Panel2Collapsed = false;
            }
            else
            {
                spl_P_DevolucionPago_Principal.Panel2Collapsed = true;
            }
        }

        private void ex_trv_P_DevolucionPago_ArbolSecundarioSeleccion_Exferia_ArbolSecundarioSeleccion_NodoSeleccion(object sender, EventArgs e)
        {
            spl_P_DevolucionPago_Principal.Panel2Collapsed = true;
        }
        #endregion

        #region Eventos del Paginador
        protected void ctu_Paginacion_Primera_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {
                if (g_obj_Funciones_Paginador.Primera())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_Devolucions.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }
        protected void ctu_Paginacion_Anterior_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {
                if (g_obj_Funciones_Paginador.Anterior())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_Devolucions.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }
        protected void ctu_Paginacion_Siguiente_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {
                if (g_obj_Funciones_Paginador.Siguiente())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_Devolucions.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }
        protected void ctu_Paginacion_Ultima_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {

                if (g_obj_Funciones_Paginador.Ultima())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_Devolucions.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }
        protected void txt_PaginaActual_KeyPress(object sender, KeyPressEventArgs e)
        {
            // Si pulsamos Enter.
            if (e.KeyChar.Equals('\r'))
            {
                if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
                {
                    // Asignamos a la paginacion el valor del textbox
                    g_obj_Funciones_Paginador.SetPaginaActual(Exferia_Paginador_Devolucions.txt_ValorPaginaActual - 1);

                    // Asignando al control la pagina actual.
                    Exferia_Paginador_Devolucions.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();

                    g_obj_Controladora.RecargarDatos();
                }
            }
        }
        #endregion

        #region Teclas de acceso rapido

        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            // Salir sin Seleccionar
            if (keyData == Keys.F10)
            {
                Salir_P_Base();
                return true;
            }
            // Grabar
            else if (keyData == Keys.F2)
            {
                Grabar();
                return true;
            }
            // Borrar
            else if (keyData == Keys.F5)
            {
                Borrar();
                return true;
            }
            return base.ProcessCmdKey(ref msg, keyData);
        }

        #endregion

        #region Controlar si se modifica algo
        private void Controlar_Modificaciones_TextBox_TextChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }

        private void Controlar_Modificaciones_CheckBox_CheckedChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }

        private void Controlar_Modificaciones_Exferia_FechaSeleccion_TextChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }

        private void Controlar_Modificaciones()
        {
            if (Enabled && g_obj_Controladora != null && g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial)
            {
                P_Base_SeModificoDatosPantalla = true;
            }
        }

        #endregion

        #region Validar Fecha que este dentro de Ejercicio
        private void ex_usc_P_Devolucion_Fecha_Exferia_FechaSeleccion_LostFocus(object sender, EventArgs e)
        {
            //Sino esta Bloqueado valido
            if (ex_usc_P_DevolucionPago_Fecha.Exferia_FechaSeleccion_ReadOnly == false)
            {
                if (ex_usc_P_DevolucionPago_Fecha.Exferia_FechaSeleccion_Fecha.Trim(' ', '/') != "" && Funciones.Fecha_Validacion(ex_usc_P_DevolucionPago_Fecha.Exferia_FechaSeleccion_Fecha) == 0)
                {
                    //validar la Fecha para Ejercicio
                    INTERNO_ValidacionFechas_Modelo mdl_INTERNO_ValidacionFechas_Modelo = Datos_Generales.GEN_EjerciciosActivos_Empresa_Validar_Por_FechaEjercicio(DateTime.ParseExact(ex_usc_P_DevolucionPago_Fecha.Exferia_FechaSeleccion_Fecha, "dd/MM/yyyy", CultureInfo.InvariantCulture),
                                                                                                                            P_Base_ValoresGenerales.EjercicioActivo,
                                                                                                                            P_Base_ValoresGenerales.Ejercicios_Listado.ToList());

                    //Sino es Correcto
                    if (!mdl_INTERNO_ValidacionFechas_Modelo.Accion.Equals(G_ENUM_VALIDACIONFECHAS.Correcto))
                    {
                        //Mostrar Mensaje
                        Mensajes.MostrarMensaje(mdl_INTERNO_ValidacionFechas_Modelo.Mensaje);

                        //Si es Error o Incorrecto debe poner el Foco la Fecha
                        if (mdl_INTERNO_ValidacionFechas_Modelo.Accion.Equals(G_ENUM_VALIDACIONFECHAS.Error) ||
                            mdl_INTERNO_ValidacionFechas_Modelo.Accion.Equals(G_ENUM_VALIDACIONFECHAS.Incorrecta))
                        {
                            //Poner el Foco en el objeto que tuvo el problema en validar
                            ex_lbl_Advertencia_Ejercicio.Text = "";
                            ex_usc_P_DevolucionPago_Fecha.g_bol_Activo = false;
                            ex_usc_P_DevolucionPago_Fecha.Focus();
                        }
                        else
                        {
                            ex_lbl_Advertencia_Ejercicio.Text = Mensajes.G_STR_MENSAJES_FECHASEJERCICIOS_ETIQUETA_FUERAEJERCICIO();
                            ex_usc_P_DevolucionPago_Fecha.g_bol_Activo = false;
                            ex_usc_F3_P_DevolucionPago_Tesoreria.Exferia_F3_SoloSeleccion_Foco();
                        }
                    }
                    else
                    {
                        ex_lbl_Advertencia_Ejercicio.Text = "";
                    }
                }
                else
                {
                    ex_lbl_Advertencia_Ejercicio.Text = "";
                }
            }
        }

        #endregion

        #region Cierre de Pantalla
        private void P_DevolucionPago_FormClosed(object sender, FormClosedEventArgs e)
        {
            try
            {
                #region DATOS DEL MANTENIMIENTO
                //Guardar el fichero xml de configuracion de la pantalla
                INTERNO_ConfiguracionPantalla_Modelo mdl_INTERNO_ConfiguracionPantalla_Modelo = new INTERNO_ConfiguracionPantalla_Modelo();

                //Centro de Informacion Ancho
                mdl_INTERNO_ConfiguracionPantalla_Modelo.CENTROINFORMACION_Ancho = g_int_CentroInformacion_Ancho;

                //Actualizar la Variables General
                if (Variables.G_DCT_CONFIGURACIONPANTALLA != null && Variables.G_DCT_CONFIGURACIONPANTALLA.Count > 0)
                {
                    //Ver si ya existia
                    if (Variables.G_DCT_CONFIGURACIONPANTALLA.ContainsKey(nameof(P_DevolucionPago)))
                    {
                        Variables.G_DCT_CONFIGURACIONPANTALLA[nameof(P_DevolucionPago)] = mdl_INTERNO_ConfiguracionPantalla_Modelo;
                    }
                    else
                    {
                        Variables.G_DCT_CONFIGURACIONPANTALLA.Add(nameof(P_DevolucionPago), mdl_INTERNO_ConfiguracionPantalla_Modelo);
                    }
                }
                else
                {
                    Variables.G_DCT_CONFIGURACIONPANTALLA = new Dictionary<string, INTERNO_ConfiguracionPantalla_Modelo>();
                    Variables.G_DCT_CONFIGURACIONPANTALLA.Add(nameof(P_DevolucionPago), mdl_INTERNO_ConfiguracionPantalla_Modelo);
                }

                //Actualizar el fichero XML
                Exferia_Aplicacion.General.Funciones_FicherosXML.ModificarXML_ConfiguracionPantallas(Variables.G_STR_CONFIGURACIONPANTALLA_TIPOPANTALLA_MANTENIMIENTO, nameof(P_DevolucionPago), mdl_INTERNO_ConfiguracionPantalla_Modelo);
                #endregion
            }
            catch (Control_Errores)
            { }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_DevolucionPago) + "/" + nameof(P_DevolucionPago_FormClosed));
            }
        }
        #endregion

        #region Centro de Informacion
        private void P_DevolucionPago_SizeChanged(object sender, EventArgs e)
        {
            //calcular distancia del splitter
            spl_P_DevolucionPago_Principal.SplitterDistance = spl_P_DevolucionPago_Principal.Width - g_int_CentroInformacion_Ancho;
        }

        private void spl_P_DevolucionPago_Principal_Panel2_SizeChanged(object sender, EventArgs e)
        {
            try
            {
                if (spl_P_DevolucionPago_Principal.Panel2.Width > 0 &&
                    spl_P_DevolucionPago_Principal.Panel2.Height > 0)
                {
                    ex_trv_P_DevolucionPago_ArbolSecundarioSeleccion.Size = new Size(spl_P_DevolucionPago_Principal.Panel2.Width - 2, spl_P_DevolucionPago_Principal.Panel2.Height - 2);
                }

                g_int_CentroInformacion_Ancho = spl_P_DevolucionPago_Principal.Width - spl_P_DevolucionPago_Principal.SplitterDistance;
            }
            catch (Exception)
            { }
        }
        #endregion


    }
}
